/*
oop_ex90.cpp
overloading ++ and --, using non-function members
*/

#include <iostream>

using namespace std;

class Time
{
	int hour;
	int minute;
	int second;

public:
	friend ostream& operator<<(ostream&, Time&);

	friend Time& operator++(Time&);
	friend Time& operator++(Time&, int);

	Time(int h = 0, int m = 0, int s = 0);
	Time& addTime(int h, int m, int s);
	Time& setTime(int h, int m, int s);


};


Time& operator++(Time& t)
{
	cout << "pre++" << endl;
	t.second++;
	if (t.second >= 60)
	{
		int a = t.second / 60;
		t.minute += a;
		t.second %= 60;
	}

	if (t.minute >= 60)
	{
		int a = t.minute / 60;
		t.hour += a;
		t.minute %= 60;
	}

	if (t.hour >= 24)
		t.hour %= 24;

	return t;	//using this to enable chained function calls
}

Time& operator++(Time& t, int i)
{
	cout << "post++" << endl;

	Time& Temp = t;

	t.second++;
	if (t.second >= 60)
	{
		int a = t.second / 60;
		t.minute += a;
		t.second %= 60;
	}

	if (t.minute >= 60)
	{
		int a = t.minute / 60;
		t.hour += a;
		t.minute %= 60;
	}

	if (t.hour >= 24)
		t.hour %= 24;

	return Temp;	//return non-incremented, pre-saved temporary object
					//value return, not a reference return
}

ostream& operator<<(ostream& os, Time& t)
{
	cout << t.hour << ":" << t.minute << ":" << t.second;
	return os;
}



Time::Time(int h, int m, int s)
{
	hour = ((h<24 && h >= 0) ? h : 0);
	minute = ((m<60 && m >= 0) ? m : 0);
	second = ((s<60 && s >= 0) ? s : 0);
}


Time& Time::addTime(int h, int m, int s)
{
	hour += h;
	minute += m;
	second += s;

	if (second >= 60)
	{
		int a = second / 60;
		minute += a;
		second %= 60;
	}

	if (minute >= 60)
	{
		int a = minute / 60;
		hour += a;
		minute %= 60;
	}

	if (hour >= 24)
		hour %= 24;

	return *this;	//using this to enable chained function calls
}

Time& Time::setTime(int h, int m, int s)
{
	hour = ((h<24 && h >= 0) ? h : 0);
	minute = ((m<60 && m >= 0) ? m : 0);
	second = ((s<60 && s >= 0) ? s : 0);
	return *this;	//using this to enable chained function calls
}


//=======================


void main()
{
	Time showtime(16, 30);

	cout << "showtime is " << showtime << endl;
	cout << "++showtime is " << ++showtime << endl;
	cout << "showtime is " << showtime << endl << endl;

	cout << "showtime is " << showtime << endl;
	cout << "showtime++ is " << showtime++ << endl;
	cout << "showtime is " << showtime << endl;

	system("pause");
}


